/*************************************************
* Certificate Store Header File                  *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#ifndef BOTAN_CERT_STORE_H__
#define BOTAN_CERT_STORE_H__

#include <botan/x509cert.h>

namespace Botan {

/*************************************************
* Certificate Store Interface                    *
*************************************************/
class Certificate_Store
   {
   public:
      virtual std::vector<X509_Certificate>
         by_name(const std::string&) const = 0;
      virtual std::vector<X509_Certificate>
         by_email(const std::string&) const = 0;
      virtual std::vector<X509_Certificate>
         by_SKID(const SecureVector<byte>&) const = 0;

      virtual X509_CRL get_crl_for(const X509_Certificate&) const = 0;

      virtual ~Certificate_Store() {}
   };

}

#endif
