/*************************************************
* BigInt Assembly Backend Header File            *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#ifndef BOTAN_MP_ASM_H__
#define BOTAN_MP_ASM_H__

#include <botan/config.h>

#ifndef WORD_BITS_NEEDED
  #define WORD_BITS_NEEDED 32
#endif

#if MP_WORD_BITS != WORD_BITS_NEEDED
  #error This assembly module is not compatible with the value of MP_WORD_BITS
#endif

#define SET_ALIGN .p2align 4,,15

#define FUNCTION(func_name)           \
        .align   8;                   \
        SET_ALIGN;                    \
        .global  func_name;           \
        .type    func_name,@function; \
func_name:

#endif
