/*************************************************
* X.509 Self-Signed Certificate Header File      *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#ifndef BOTAN_X509_SELF_H__
#define BOTAN_X509_SELF_H__

#include <botan/x509cert.h>
#include <botan/x509opt.h>
#include <botan/pkcs8.h>
#include <botan/pkcs10.h>

namespace Botan {

namespace X509 {

/*************************************************
* Create a self-signed X.509 certificate         *
*************************************************/
X509_Certificate create_self_signed_cert(const X509_Cert_Options&,
                                         const PKCS8_PrivateKey&);

/*************************************************
* Create a PKCS #10 certificate request          *
*************************************************/
PKCS10_Request create_cert_req(const X509_Cert_Options&,
                               const PKCS8_PrivateKey&);

}

}

#endif
