/*************************************************
* Memory Locking Allocator Header File           *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#include <botan/secalloc.h>
#include <vector>

#ifndef BOTAN_EXT_MLOCK_ALLOCATOR_H__
#define BOTAN_EXT_MLOCK_ALLOCATOR_H__

namespace Botan {

/*************************************************
* Memory Locking Allocator                       *
*************************************************/
class MemoryLocking_Allocator : public SecureAllocator
   {
   public:
      SecureAllocator* clone() { return this; }

      MemoryLocking_Allocator(u32bit = 4);
      ~MemoryLocking_Allocator();
   private:
      struct Buffer { void* buf; u32bit length; bool in_use; };

      void* alloc_block(u32bit) const;
      void dealloc_block(void*, u32bit) const;

      u32bit check_size(u32bit) const;
      mutable std::vector<Buffer> allocated;
   };

}

#endif
