/*************************************************
* BeOS EntropySource Source File                 *
* (C) 1999-2003 The Botan Project                *
*************************************************/

#include <botan/es_beos.h>
#include <botan/util.h>
#include <kernel/OS.h>

namespace Botan {

/*************************************************
* Fast Poll                                      *
*************************************************/
void BeOS_EntropySource::do_fast_poll()
   {
   system_info sys_info;
   get_system_info(&sys_info);
   add_bytes(&sys_info, sizeof(system_info));
   }

/*************************************************
* Slow Poll                                      *
*************************************************/
void BeOS_EntropySource::do_slow_poll()
   {
   team_info info_team;
   int32 team_cookie = 0;
   while(get_next_team_info(&team_cookie, &info_team) == B_OK)
      {
      add_bytes(&info_team, sizeof(team_info));

      thread_info info_thr;
      int32 thr_cookie = 0;
      team_id id = info_team.team;

      while(get_next_thread_info(id, &thr_cookie, &info_thr) == B_OK)
         add_bytes(&info_thr, sizeof(thread_info));
      }
   }

}
